package com.company.test.entity

import io.jmix.core.DataManager
import io.jmix.core.entity.annotation.JmixGeneratedValue
import io.jmix.core.entity.annotation.JmixId
import io.jmix.core.metamodel.annotation.InstanceName
import io.jmix.core.metamodel.annotation.JmixEntity
import jakarta.annotation.PostConstruct
import java.util.*

@JmixEntity(name = "jt_TestDto")
open class TestDto {
    @JmixGeneratedValue
    @JmixId
    var id: UUID? = null

    @InstanceName
    var name: String? = "test"

    var testDtoChild: BaseDtoChild? = null


    @PostConstruct
    fun postConstruct(dataManager: DataManager) {
        testDtoChild = dataManager.create(BaseDtoChild::class.java)
    }
}