package com.company.test.view.testdto

import com.company.test.entity.TestDto
import com.company.test.view.main.MainView
import com.vaadin.flow.router.Route
import io.jmix.core.LoadContext
import io.jmix.core.SaveContext
import io.jmix.flowui.view.*
import io.jmix.flowui.view.Target

@Route(value = "testDtoes/:id", layout = MainView::class)
@ViewController("jt_TestDto.detail")
@ViewDescriptor("test-dto-detail-view.xml")
@EditedEntityContainer("testDtoDc")
class TestDtoDetailView : StandardDetailView<TestDto>() {

    @Install(to = "testDtoDl", target = Target.DATA_LOADER)
    private fun testDtoDlLoadDelegate(loadContext: LoadContext<TestDto>): TestDto? {
        val id = loadContext.id
        // Here you can load the entity by id from an external storage.
        // Set the loaded entity to the not-new state using EntityStates.setNew(entity, false).
        return null
    }

    @Install(target = Target.DATA_CONTEXT)
    private fun saveDelegate(saveContext: SaveContext): MutableSet<Any> {
        // Here you can save the entity to an external storage and return the saved instance.
        // Set the returned entity to the not-new state using EntityStates.setNew(entity, false).
        // If the new entity ID is assigned by the storage, set the ID to the original instance too 
        // to let the framework match the saved instance with the original one.
        val savedEntity = editedEntity
        return mutableSetOf(savedEntity)
    }
}
